/*
** $Id: modlua_config.h,v 1.1.1.1 2003/06/30 19:18:25 michel Exp $
** mod_lua - Apache module for Lua language
** See copyright notice in distro's COPYRIGHT file
*/

#ifndef modlua_config_h
#define modlua_config_h

#include <httpd.h>
#include <http_config.h>

#define EVENT_POSTREADREQUEST   0
#define EVENT_TRANS             1
#define EVENT_HEADERPARSER      2
#define EVENT_ACCESS            3
#define EVENT_AUTHEN            4
#define EVENT_AUTHZ             5
#define EVENT_TYPE              6
#define EVENT_FIXUP             7
#define EVENT_RESPONSE          8
#define EVENT_LOG               9

#define EVENT_FIRST             EVENT_POSTREADREQUEST 
#define EVENT_LAST              EVENT_LOG

typedef struct {
    const char *path;
} modlua_config_srv_t;

typedef struct {
    array_header *handlers[EVENT_LAST+1];
} modlua_config_dir_t;

void *modlua_config_srv_create(pool *p, server_rec *s);
void *modlua_config_srv_merge(pool *p, void *basev, void *addv);
void *modlua_config_dir_create(pool *p, char *dir);
void *modlua_config_dir_merge(pool *p, void *basev, void *addv);

const char *modlua_cmd_path(cmd_parms *parms, void *mconfig, const char *arg);
const char *modlua_cmd_require(cmd_parms *parms, void *mconfig,
                               const char *arg);
const char *modlua_cmd_handler(cmd_parms *parms, void *mconfig,
                               const char *arg);

#endif
